# -*- coding: utf-8 -*-

# This file is part of the Gedit LaTeX Plugin
#
# Copyright (C) 2007 Michael Zeising
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public Licence as published by the Free Software
# Foundation; either version 2 of the Licence, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for more 
# details.
#
# You should have received a copy of the GNU General Public Licence along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA  02110-1301, USA

from re import compile
from os.path import dirname
from gtk import RESPONSE_OK

def ArchiveController(object):
	#
	# TODO: we also need to parse for referenced bib files
	# TODO: scanning should be recursive (scan the slaves too)
	#
	def __init__(self):
		self.__p = compile("\\include.*?\{(?P<file>[\w\.]+)\}")
		self.__dialog = None
		
	def __scan(self, filename):
		"""
		Scan the source file for referenced files
		"""
		try:
			s = open(filename).read()
			return [m.group("file") for m in self.__p.finditer(s)]
		except IOError, e:
			return []
	
	def __run(self, files, dest):
		"""
		Create an archive of a list of files and save it to a destination
		"""
		pass
	
	def archive(self, filename):
		d = dirname(filename)
		
		l = ["%s/%s" % (d, f) for f in self.__scan(filename)]
		l.append(filename)
		
		if not self.__dialog:
			self.__dialog = ArchiveDialog()
		
		self.__dialog.set_files(l)
		
		if self.__dialog.run() == RESPONSE_OK:
			self.__run(self.__dialog.get_selected_files(), self.__dialog.get_destination())
		
		self.__dialog.hide()
		
		