# -*- coding: utf-8 -*-

# This file is part of the Gedit LaTeX Plugin
#
# Copyright (C) 2007 Michael Zeising
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public Licence as published by the Free Software
# Foundation; either version 2 of the Licence, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for more 
# details.
#
# You should have received a copy of the GNU General Public Licence along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA  02110-1301, USA

from os.path import basename
from xml.sax.saxutils import escape

from LaTeXPlugin.Logger import error

ERROR, WARNING = 0, 1

class Message(object):
	"""
	This encapsulates a message produced by a LaTeX compiling backend
	"""
	def __init__(self, filename=None, line_from=None, line_to=None, text=None, severity=ERROR):
		self.filename = filename
		
		self.line_from = None
		if line_from:
			try:
				self.line_from = int(line_from)
			except ValueError, s:
				error(self, "__init__", s)
		
		self.line_to = None
		if line_to:
			try:
				self.line_to = int(line_to)
			except ValueError, s:
				error(self, "__init__", s)
		
		self.text = escape(text)
		self.severity = severity
	
	def get_basename(self):
		if self.filename:
			return basename(self.filename)
		else:
			return None
