# -*- coding: utf-8 -*-

# This file is part of the Gedit LaTeX Plugin
#
# Copyright (C) 2007 Michael Zeising
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public Licence as published by the Free Software
# Foundation; either version 2 of the Licence, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for more 
# details.
#
# You should have received a copy of the GNU General Public Licence along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA  02110-1301, USA

from LaTeXPlugin.common import ConditionalSource
from LaTeXPlugin.sourcebuilder import *

class ListingSourceBuilder(object):
	def __init__(self):
		self.filename = None
		
		self.language = None
		self.dialect = None
		
		self.breaklines = False
		self.show_string_spaces = False
		
		self.caption = None
		self.label = None
		
		self.tabsize = 4
	
	@property
	def source(self):
		s_lstset = "\\lstset{language="
		
		if self.language:
			if self.dialect and len(self.dialect):
				s_lstset += "[%s]" % self.dialect
			s_lstset += self.language
		else:
			s_lstset += "{}"
		
		s_lstset += ",tabsize=%s" % self.tabsize
		
		s_lstset += "}"
		
		if self.filename:
			s = s_lstset + "\n\\lstinputlisting{%s}" % self.filename
		else:
			s = [s_lstset + "\n\\begin{lstlisting}\n\t", "\n\\end{lstlisting}"]
		
		return ConditionalSource(s, ["listings"])

#	@property
#	def source(self):
#		lstset = Command("lstset")
#		
#		options = {}
#		
#		if self.language:
#			if self.dialect:
#				options["language"] = "[%s]%s" % (self.dialect, self.language)
#			else:
#				options["language"] = self.language
#		else:
#			options["language"] = "{}"
#		
#		lstset.arguments.append(MandatoryArgument(options))
#		
#		if self.filename:
#			inlist = Command("lstinputlisting")
#			inlist.arguments.append(MandatoryArgument(self.filename))
#			
#			return ConditionalSource(str(lstset) + "\n" + str(inlist), ["listings"])
#		else:
#			lst = Environment() # problem: place the cursor in this env!
		
		