# -*- coding: utf-8 -*-

# This file is part of the Gedit LaTeX Plugin
#
# Copyright (C) 2007 Michael Zeising
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public Licence as published by the Free Software
# Foundation; either version 2 of the Licence, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for more 
# details.
#
# You should have received a copy of the GNU General Public Licence along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA  02110-1301, USA


class Environment(list):
	def __init__(self, name):
		self.name = name
		self.arguments = []
	
	def __str__(self):
		return "\\begin{%s}%s\n%s\n\\end{%s}" % (self.name, "".join([str(a) for a in self.arguments]), "\n".join([str(c) for c in self]), self.name)


class Command(object):
	def __init__(self, name):
		self.name = name
		self.arguments = []
	
	def __str__(self):
		return "\\%s%s" % (self.name, "".join([str(a) for a in self.arguments]))
		

class MandatoryArgument(object):
	def __init__(self, value):
		self.value = value
	
	def __str__(self):
		if type(self.value) is dict:
			return "{%s}" % ",".join(["%s=%s" % (k, v) for k, v in self.value.iteritems()])
		else:
			return "{%s}" % str(self.value)


class OptionalArgument(object):
	def __init__(self, value):
		self.value = value
	
	def __str__(self):
		if type(self.value) is dict:
			return "[%s]" % ",".join(["%s=%s" % (k, v) for k, v in self.value.iteritems()])
		else:
			return "[%s]" % str(self.value)